import static org.junit.Assert.*;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

public class TestMain {

	// This rule is needed to check if an Exception has been thrown later
	@Rule
	public ExpectedException exception = ExpectedException.none();

	@Test
	public void testIsASmallerZero_smallerZero() {
		/*
		 * You should not put more than one Assert in a test.
		 * It keeps the the test small and debugging simple.
		 */
		assertTrue(Main.isASmallerZero(-100));
		assertTrue(Main.isASmallerZero(-2));
		assertTrue(Main.isASmallerZero(-1));
	}

	@Test
	public void testIsASmallerZero_greaterZero() {
		assertFalse(Main.isASmallerZero(0));
		assertFalse(Main.isASmallerZero(1));
		assertFalse(Main.isASmallerZero(100));
	}

	@Test
	public void testDevideOneByA_Exception() {
		// We expect an Exception because you shall not devide by zero
		exception.expect(IllegalArgumentException.class);
		Main.devideOneByA(0);
	}

	@Test
	public void testDevideOneByA_Values() {
		/*
		 * Notice the last parameter of the Assert.
		 * It is called DELTA. If the expected and actual numbers differ less than DELTA
		 * they are considered equal.
		 */
		assertEquals("1 / 10 = 0.1", 0.1, Main.devideOneByA(10), 1e-15);
		assertEquals("1 / 3 = 0.33", 0.33, Main.devideOneByA(3), 0.004);
	}

	@Test
	public void testSumUpToA_Exception() {
		// Again an Exception is expected
		exception.expect(IllegalArgumentException.class);
		Main.sumUpToA(0);
		exception.expect(IllegalArgumentException.class);
		Main.sumUpToA(-1);
	}
	
	@Test
	public void testSumUpToA_Values() {
		// We can test different implementations of a function with the same test class.
		assertEquals("sum(1) = 1", 1, Main.sumUpToA(1));
		assertEquals("sum(3) = 6", 6, Main.sumUpToA(3));
		assertEquals("sum(100) = 5050", 5050, Main.sumUpToA(100));		
	}
}
